# Advanced Hypertext Targets
By far the most dominant use of JavaScript today is for asynchronously sending requests for data to render into the webpage, a.k.a. Ajax. The benefit being that it allows the surfer to do other stuff on the page whilst the request is inflight. For JavaScript to be deprecated, this need must be satisfied.

As such this document proposes that hyperlinks should be configurable to parse their response as an HTML snippet and insert it into a specified element. And a way to specify form controls whose value should be included in the request.

## Out of scope
The spec for this should not include a means of polling the server, or a means to attach locally stored information to the request. Those deserve their own specifications and both of which are implemented by our Intercooler inspiration.

## Case studies
* https://mastodon.social/
* https://duckduckgo.com/ - This is an interesting case because they use Ajax so the page doesn't take as long to download as it's slowest data request.
* [https://www.techdirt.com/articles/20181111/09191641022/funniest-most-insightful-comments-week-techdirt.shtml](https://www.techdirt.com/articles/20181111/09191641022/funniest-most-insightful-comments-week-techdirt.shtml) - The comment section.

## Prior Work
* https://john.ankarstrom.se/english/texts/replacing-javascript/
* http://intercoolerjs.org/ - This spec will likely be based in large part on this framework.
* https://www.w3.org/TR/html52/links.html#links
* [https://www.w3.org/TR/html52/sec-forms.html#forms-form-submission](https://www.w3.org/TR/html52/sec-forms.html#forms-form-submission)

## Concerns
* Each (batch of) request must be sent only with informed and explicit permission from the surfer.
* Should we constrain which elements can be linked and how? That could help inform users.
* This spec should gracefully degrade to hyperlinks and forms as defined today.
* Browsers should not need to implement separate code paths for traditional hyperlinks and forms, and these more advanced variants.
